SLASH_GC1 = "/GearCheck";
SLASH_GC2 = "/gc";
local GearCheckVersion = "GearCheck v2.2";
local GearCheckCurrentResults = {};
local waitTable = {};
local waittime = 0;
local time = 0;
local text = "";
local GameTooltipOnShow = -1;
local GearCheckRealm = GetRealmName();

--begin localization
local L = {};
L["requestGC"] = "perform GearCheck";
L["runningGC"] = "running GearCheck"
L["PartyReport"] = "Party-GearCheck:";
L["RaidReport"] = "Raid-GearCheck:";
L["GuildReport"] = "Guild-GearCheck:";
L["TargetReport"] = "Gear-Check of ";
L["requestinformation"] = "RIL = Real-Item-Level, BIL = Blizzard-Item-Level. There are only targets shown, that are also running this AddOn.";
L["requestinformation2"] = "RIL = Real-Item-Level, BIL = Blizzard-Item-Level. BIL and res. are only shown, if the targets are also running this AddOn. Not listed Targets are out of range.";
L["requestinformation3"] = "RIL = Real-Item-Level, BIL = Blizzard-Item-Level. BIL and res. are only shown, if the targets are also running this AddOn.";
L["noAddOn"] = " isn't using this AddOn. There are only targets shown, that are in range or also running this AddOn.";
L["noResponse"] = " doesn't respond to GearCheck-Request";
L["Report:"]="Report:";
L["ChatFrame1"]="ChatFrame1";
L["/say"]="/say";
L["/yell"]="/yell";
L["/party"]="/party";
L["/raid"]="/raid";
L["/guild"]="/guild";
L["/whisper:"]="/whisper:";
L["Options:"]="Options:";
L["lockFrames"]="Lock Frames";
L["enableMinimapButton"]="Enable Minimap-Button";
L["lockMinimapButton"]="Lock Minimap-Button";
L["Respond"] = "Respond to GC-Requests";	
L["Check:"] = "Check:";
L["party"] = "Party";
L["raid"] = "Raid";
L["guild"] = "Guild";
L["target"] = "Target: ";
L["resiliance"] = " res.";
L["resi"] = "res.";
L["Head"] = "# || RIL || BIL || name (res.)";
L["REALITEMLEVEL"] = "The average Item-Level of Your current Equip.";
L["GCdisabled"] = "GearCheck isn't possible, wait some seconds and try again";
L["Error"] = "Error: unable to register GearCheck-Message-Prefix";
L["loadingGC"] = GearCheckVersion.. " is loading";
if (GetLocale() == "deDE") then
	L["requestGC"] = "GearCheck durchf\195\188hren";
	L["runningGC"] = "bearbeite GearCheck"
	L["PartyReport"] = "Gruppen-GearCheck:";
	L["RaidReport"] = "Raid-GearCheck:";
	L["GuildReport"] = "Gilden-GearCheck:";
	L["TargetReport"] = "Gear-Check von ";
	L["requestinformation"] = "RIL = Real-Item-Level, BIL = Blizzard-Item-Level. Es werden nur Zielpersonen angezeigt, die ebenfalls dieses AddOn verwenden.";	
	L["requestinformation2"] = "RIL = Real-Item-Level, BIL = Blizzard-Item-Level. BIL und Abh. kann nur angezeigt werden, wenn die Zielpersonen ebenfalls dieses AddOn verwenden. Zielpersonen, die nicht angezeigt werden sind au\195\159er Reichweite.";
	L["requestinformation3"] = "RIL = Real-Item-Level, BIL = Blizzard-Item-Level. BIL und Abh. kann nur angezeigt werden, wenn die Zielpersonen ebenfalls dieses AddOn verwenden."
	L["noAddOn"] = " benutzt dieses AddOn nicht. Es werden nur Zielpersonen angezeigt, die sich in Reichweite befinden oder ebenfalls dieses AddOn verwenden.";
	L["noResponse"] = " beantwortet keine GearCheck-Anfragen";
	L["Report:"]="Bericht an:";
	L["ChatFrame1"]="ChatFrame1";
	L["/say"]="/sagen";
	L["/yell"]="/schreien";
	L["/party"]="/gruppe";
	L["/raid"]="/schlachtzug";
	L["/guild"]="/gilde";
	L["/whisper:"]="/fl\195\188stern:";
	L["Options:"]="Optionen:";
	L["lockFrames"]="Fenster sperren";
	L["enableMinimapButton"]="Minimap-Button anzeigen";
	L["lockMinimapButton"]="Minimap-Button sperren";
	L["Respond"] = "GC-Anfragen beantworten";		
	L["Check:"] = "\195\156berpr\195\188fe:";
	L["party"] = "Gruppe";
	L["raid"] = "Raid";
	L["guild"] = "Gilde";
	L["target"] = "Ziel: ";
	L["resiliance"] = " Abh.";
	L["resi"] = "Abh.";
	L["Head"] = "# || RIL || BIL || Name (Abh.)";
	L["REALITEMLEVEL"] = "Die durchschnittliche Gegenstandsstufe Eurer momentan angelegten Ausr\195\188stung.";
	L["GCdisabled"] = "Durchf\195\188hrung des GearChecks ist momentan nicht m\195\182glich. In einigen Sekunden erneut probieren.";
	L["Error"] = "Error: GearCheck-Message-Prefix konnte nicht registriert werden";
	L["loadingGC"] = GearCheckVersion.. " wird geladen";
else
end
--end localization
	
function GearCheckWaitFrameOnUpdate(self, elapsed)	
	time = time + elapsed;	
	local count = #waitTable;
	local i = 1;
	if (count == 0) then
		GearCheckWaitFrame:Hide();
		text = L["runningGC"];
		time = 0;		
	else
		while(i<=count) do
			--GearCheckWaitFrameText:SetText(text.." ("..GearCheckRound(time, 0).."s / "..GearCheckRound(waittime, 0).."s)");			
			local waitRecord = tremove(waitTable,i);
			local d = tremove(waitRecord,1);
			local f = tremove(waitRecord,1);
			local p = tremove(waitRecord,1);
			if(d>elapsed) then
				tinsert(waitTable,i,{d-elapsed,f,p});
				i = i + 1;
			else
				count = count - 1;
				f(unpack(p));
			end
		end
	end
end

function GearCheckWait(delay, func, ...)
	if(type(delay)~="number" or type(func)~="function") then
		return false;
	end
	if(not(GearCheckWaitFrame:IsShown())) then
		GearCheckWaitFrame:Show();
	end
	tinsert(waitTable,{delay,func,{...}});
	return true;
end

function GearChecktobool(arg1)
	if arg1 == 1 or arg1 == true then
		return true;
	else
		return false;
	end
end

function GearCheckRound(number, decimals)
    return (("%%.%df"):format(decimals)):format(number)
end

function GearCheckGetCurrentAverageItemLevel(unit)
	local ril = 0;
	local j = 16;
	for i=1, 3 do
		local itemID = GetInventoryItemID(unit, i);
		if (not (itemID == nil)) then		
			local _, _, _, itemLevel, _, _, _, _, _, _, _= GetItemInfo(itemID);
			if (not (itemLevel == nil)) then
				ril = ril + itemLevel;				
			end
		end
	end
	for i=5, 15 do
		local itemID = GetInventoryItemID(unit, i);
		if (not (itemID == nil)) then		
			local _, _, _, itemLevel, _, _, _, _, _, _, _= GetItemInfo(itemID);
			if (not (itemLevel == nil)) then
				ril = ril + itemLevel;
			end
		end
	end
	local itemID = GetInventoryItemID(unit, 16);
	if (not (itemID == nil)) then		
		local _, _, _, itemLevel, _, itemType, _, _, _, _, _= GetItemInfo(itemID);
		if (not (itemLevel == nil)) then
			ril = ril + itemLevel;
		end
		if (itemType == "One-Hand") then
			itemID = GetInventoryItemID(unit, 17);
			if (not (itemID == nil)) then		
				local _, _, _, itemLevel, _, _, _, _, _, _, _= GetItemInfo(itemID);
				if (not (itemLevel == nil)) then
					ril = ril + itemLevel;
				end
			end
			j = j + 1;
		elseif (itemType == "Two-Hand") then
			itemID = GetInventoryItemID(unit, 17);
			if (not (itemID == nil)) then		
				local _, _, _, itemLevel, _, _, _, _, _, _, _= GetItemInfo(itemID);
				if (not (itemLevel == nil)) then
					ril = ril + itemLevel;
				end
				j = j + 1;
			end			
		end
	else
		itemID = GetInventoryItemID(unit, 17);
		if (not (itemID == nil)) then		
			local _, _, _, itemLevel, _, _, _, _, _, _, _= GetItemInfo(itemID);
			ril = ril + itemLevel;
		end
		j = j + 1;
	end
	itemID = GetInventoryItemID(unit, 18);
	if (not (itemID == nil)) then		
		local _, _, _, itemLevel, _, _, _, _, _, _, _= GetItemInfo(itemID);
		ril = ril + itemLevel;
	end
	ril = ril / j;	
	return ril;
end

function GearCheckGetResiliance()
	return(GetCombatRating(16));
end

function GearCheckRespond(target)	
	if(not(target == GetUnitName("PLAYER"))) then
	SendAddonMessage("GearCheck", "."..GearCheckVersion, "WHISPER", target);
		if GearCheck_Respond then
			SendAddonMessage("GearCheck", "!"..GearCheckRound(GetAverageItemLevel(), 0)..","..GearCheckRound(GearCheckGetCurrentAverageItemLevel("player"), 0)..","..GearCheckGetResiliance(), "WHISPER", target);		
		else		
			SendAddonMessage("GearCheck", "-", "WHISPER", target);
		end
	end
end

function GearCheckInspect(target, mode)
	if mode == "PARTY" then
		local name = GetUnitName(target, true);
		if (not (UnitIsSameServer(target, "PLAYER"))) then
			local n, r = UnitName(target);
			if (not(r == nil)) then
				name = n.."-"..r;			
			end			
		end
		if (CheckInteractDistance(target, 1)) then
			GearCheckCurrentResults[name] = {tonumber((GearCheckRound((GearCheckGetCurrentAverageItemLevel(target)), 0))), -1, -1};			
		else
			GearCheckCurrentResults[name] = {-2, -2, -2};			
		end
	elseif mode == "RAID" then
		local name = GetUnitName(target, true);	
		if (CheckInteractDistance(target, 1)) then
			GearCheckCurrentResults[name] = {tonumber((GearCheckRound((GearCheckGetCurrentAverageItemLevel(target)), 0))), -1, -1};			
		else
			GearCheckCurrentResults[name] = {-2, -2, -2};			
		end
	else
		if (CheckInteractDistance(mode, 1)) then
			GearCheckCurrentResults[target] = {tonumber((GearCheckRound((GearCheckGetCurrentAverageItemLevel(mode)), 0))), -1, -1};			
		else
			GearCheckCurrentResults[target] = {-2, -2, -2};
		end
	end
end

function GearCheckProcessData(mode)
	if (not(GearCheckCurrentResults == nil)) then	
		if ((mode == "PARTY") or (mode == "RAID") or (mode == "GUILD")) then
			local GearCheckSortedDB = GearCheckSort(GearCheckCurrentResults);
			if mode == "PARTY" then
				GearCheckReport(L["PartyReport"]);
			elseif mode == "RAID" then
				GearCheckReport(L["RaidReport"]);
			elseif mode == "GUILD" then
				GearCheckReport(L["GuildReport"]);
			end
			GearCheckReport(L["Head"]);
			for i, name in ipairs(GearCheckSortedDB) do			
				local name3 = name;
				local pos = strfind(name, "-");
				if pos == nil then
					name3 = name3.."-"..GearCheckRealm;
				end
				if GearCheckCurrentResults[name][1] >= 0 then
					GearCheckDB[name3] = GearCheckCurrentResults[name];
					tinsert(GearCheckDB[name3], date("%d.%m.%y %H:%M:%S"));					
					if GearCheckCurrentResults[name][3] > 0 then
						GearCheckReport(i..". || "..GearCheckCurrentResults[name][1].." || "..GearCheckCurrentResults[name][2].." || "..name.." ("..GearCheckCurrentResults[name][3]..")");						
					elseif GearCheckCurrentResults[name][3] == -1 then
						GearCheckReport(i..". || "..GearCheckCurrentResults[name][1].." || N/A || "..name);						
					else
						GearCheckReport(i..". || "..GearCheckCurrentResults[name][1].." || "..GearCheckCurrentResults[name][2].." || "..name);
					end
				elseif GearCheckCurrentResults[name][1] == -1 then
					GearCheckReport(i..". "..name2..L["noResponse"]);
				end
			end
			if ((mode == "PARTY") or (mode == "RAID")) then
				GearCheckReport(L["requestinformation2"]);		
			elseif mode == "GUILD" then
				GearCheckReport(L["requestinformation"]);
			end
		else
			local name = GetUnitName(mode, true);
			if (not(GearCheckCurrentResults[name] == nil)) then
				local name3 = name;
				local pos = strfind(name, "-");
				if pos == nil then
					name3 = name3.."-"..GearCheckRealm;
				end
				if GearCheckCurrentResults[name][1] >= 0 then
					GearCheckDB[name3] = GearCheckCurrentResults[name];
					tinsert(GearCheckDB[name3], date("%d.%m.%y %H:%M:%S"));
					GearCheckReport(L["TargetReport"]..name..":");						
					if GearCheckCurrentResults[name][3] > 0 then
						GearCheckReport("RIL: "..GearCheckCurrentResults[name][1]);
						GearCheckReport("BIL: "..GearCheckCurrentResults[name][2]);
						GearCheckReport(L["resi"]..": "..GearCheckCurrentResults[name][3]);					
					elseif GearCheckCurrentResults[name][3] == -1 then
						GearCheckReport("RIL: "..GearCheckCurrentResults[name][1]);
						GearCheckReport("BIL: N/A");
						GearCheckReport(L["resi"]..": N/A");						
					else
						GearCheckReport("RIL: "..GearCheckCurrentResults[name][1]);
						GearCheckReport("BIL: "..GearCheckCurrentResults[name][2]);
					end
					GearCheckReport(L["requestinformation3"]);
				elseif GearCheckCurrentResults[name][1] == -1 then
					GearCheckReport(name..L["noResponse"]);
				end
			end
		end
	end
end

function GearCheckFrameRequestButtonEnable()
	GearCheckFrameRequestButton:SetText(L["requestGC"]);
	GearCheckFrameRequestButton:Enable();	
end

function GearCheckFrameRequestButtonDisable()
	GearCheckFrameRequestButton:SetText(L["runningGC"]);
	GearCheckFrameRequestButton:Disable();
	wipe(GearCheckCurrentResults);	
end

function GearCheckCollectData(mode)
	local name = GetUnitName("PLAYER");	
	if ((mode == "PARTY") and (GetNumPartyMembers() > 0)) then				
		if GearCheck_Respond then			
			GearCheckCurrentResults[name] = {tonumber((GearCheckRound((GearCheckGetCurrentAverageItemLevel("PLAYER")), 0))), tonumber(GearCheckRound(GetAverageItemLevel(), 0)), tonumber(GearCheckGetResiliance())};
		else
			GearCheckCurrentResults[name] = {-1, -1, -1};
		end		
		for i = 1, 4 do			
			local x = "party"..i;
			name = GetUnitName(x, true);
			if (not(name == nil)) then
				if (CheckInteractDistance(x, 1)) then				
					if (((GearCheckCurrentResults[name] == nil) or (GearCheckCurrentResults[name][2] == nil)) and CanInspect(x)) then
						GearCheckWait(waittime, _G.NotifyInspect, x);
						waittime = waittime + 0.2;	--0.2
						GearCheckWait(waittime, GearCheckInspect, x, mode);
						waittime = waittime + 0.1;	--0.3
						GearCheckWait(waittime, GearCheckInspect, x, mode);
						waittime = waittime + 0.1;	--0.4
						GearCheckWait(waittime, ClearInspectPlayer);
						waittime = waittime + 0.1;	--0.5
					end
				else
					GearCheckCurrentResults[name] = {-2, -2, -2};
				end
			end
		end
	elseif ((mode == "RAID") and (GetNumRaidMembers() > 0)) then		
		if GearCheck_Respond then			
			GearCheckCurrentResults[name] = {tonumber((GearCheckRound((GearCheckGetCurrentAverageItemLevel("PLAYER")), 0))), tonumber(GearCheckRound(GetAverageItemLevel(), 0)), tonumber(GearCheckGetResiliance())};
		else
			GearCheckCurrentResults[name] = {-1, -1, -1};
		end	
		local j = GetNumRaidMembers();
		for i = 1, j do
			local x = "raid"..i;
			name = GetUnitName(x, true);
			if (not(name == nil)) then
				if (CheckInteractDistance(x, 1)) then
					if (((GearCheckCurrentResults[name] == nil) or (GearCheckCurrentResults[name][2] == nil)) and CanInspect(x)) then
						GearCheckWait(waittime, _G.NotifyInspect, x);
						waittime = waittime + 0.2;	--0.2
						GearCheckWait(waittime, GearCheckInspect, x, mode);
						waittime = waittime + 0.1;	--0.3
						GearCheckWait(waittime, GearCheckInspect, x, mode);
						waittime = waittime + 0.1;	--0.4
						GearCheckWait(waittime, ClearInspectPlayer);
						waittime = waittime + 0.1;	--0.5
					end
				else
					GearCheckCurrentResults[name] = {-2, -2, -2};
				end
			end
		end
	elseif (mode == "GUILD") then
		if GearCheck_Respond then			
			GearCheckCurrentResults[name] = {tonumber((GearCheckRound((GearCheckGetCurrentAverageItemLevel("PLAYER")), 0))), tonumber(GearCheckRound(GetAverageItemLevel(), 0)), tonumber(GearCheckGetResiliance())};
		else
			GearCheckCurrentResults[name] = {-1, -1, -1};
		end
	else
		if (CheckInteractDistance(mode, 1)) then
			name = GetUnitName(mode, true);			
			if (((GearCheckCurrentResults[name] == nil) or (GearCheckCurrentResults[name][2] == nil)) and CanInspect(mode)) then
				GearCheckWait(waittime, _G.NotifyInspect, mode);
				waittime = waittime + 0.2; --0.2
				GearCheckWait(waittime, GearCheckInspect, name, mode);
				waittime = waittime + 0.1; --0.3
				GearCheckWait(waittime, GearCheckInspect, name, mode);
				waittime = waittime + 0.1; --0.4
				GearCheckWait(waittime, ClearInspectPlayer);
				waittime = waittime + 0.1; --0.5
			end
		else
			name = GetUnitName(mode, true);			
			GearCheckCurrentResults[name] = {-2, -2, -2};
		end
	end
	GearCheckWait(waittime, GearCheckProcessData, mode);
	waittime = waittime + 3;
	GearCheckWait(waittime, GearCheckFrameRequestButtonEnable);
end

function GearCheckRequest(channel)
	if GearCheckFrameRequestButton:IsEnabled() then	
		local guild = GetGuildInfo("PLAYER");
		if ((channel == "PARTY") and (GetNumPartyMembers() > 0)) then			
			GearCheckFrameRequestButtonDisable();
			GearCheckSendAddonMessageRequest(channel);
			waittime = 0.6;
			GearCheckWait(waittime, GearCheckSendAddonMessageRequest, channel);
			waittime = 1.3;
			GearCheckWait(waittime, GearCheckSendAddonMessageRequest, channel);
			waittime = 1.5;
			GearCheckWait(waittime, GearCheckCollectData, channel);
		elseif ((channel == "RAID") and (GetNumRaidMembers() > 0)) then			
			GearCheckFrameRequestButtonDisable();
			GearCheckSendAddonMessageRequest(channel);
			waittime = 1;
			GearCheckWait(waittime, GearCheckSendAddonMessageRequest, channel);
			waittime = 1.8;
			GearCheckWait(waittime, GearCheckSendAddonMessageRequest, channel);
			waittime = 2;
			GearCheckWait(waittime, GearCheckCollectData, channel);
		elseif ((channel == "GUILD") and (not(guild == nil))) then			
			GearCheckFrameRequestButtonDisable();
			GearCheckSendAddonMessageRequest(channel);
			waittime = 1;
			GearCheckWait(waittime, GearCheckSendAddonMessageRequest, channel);
			waittime = 1.8;
			GearCheckWait(waittime, GearCheckSendAddonMessageRequest, channel);
			waittime = 2;
			GearCheckWait(waittime, GearCheckCollectData, channel);
		elseif ((not(channel == "PARTY")) and (not(channel == "RAID")) and (not(channel == "GUILD"))) then
			local name = GetUnitName(channel, true);			
			if (not (UnitIsSameServer(channel, "PLAYER"))) then
				name = gsub(name, " ", "");
			end			
			GearCheckFrameRequestButtonDisable();
			GearCheckSendAddonMessageRequest(name);
			waittime = 0.2;
			GearCheckWait(waittime, GearCheckCollectData, channel);
		end
	else
		print(L["GCdisabled"]);
	end
end

function GearCheckSendAddonMessageRequest(channel)
	if channel == "PARTY" or "RAID" or "GUILD" then
		SendAddonMessage("GearCheck", "?", channel);
	else
		SendAddonMessage("GearCheck", "?", "WHISPER", channel);
	end
end

function GearCheckSort(db)
	local database = {};
	for name, a in pairs(db) do
		if (#database == 0) then
			database[1] = name;
		else		
			local n = #database;
			local i = 1;
			while i <= n do
				if (tonumber(a[1]) > tonumber(db[database[i]][1])) then
					tinsert(database, i, name);
					i = n;
				elseif(tonumber(a[1]) == tonumber(db[database[i]][1])) then
					if (tonumber(a[2]) > tonumber(db[database[i]][2])) then
						tinsert(database, i, name);
						i = n;
					elseif (tonumber(a[2]) == tonumber(db[database[i]][2])) then
						if name < database[i] then
							tinsert(database, i, name);
							i = n;					
						end
					end
				elseif (i == n) then
					tinsert(database, name);
				end
				i = i + 1;
			end
		end
	end
	return database
end

function GearCheckReport(message)
	if GearCheckReportTo["ChatFrame1"] then
		print(message);
	end
	if GearCheckReportTo["Say"] then
		SendChatMessage(message, "SAY");
	end
	if GearCheckReportTo["Yell"] then
		SendChatMessage(message, "YELL");
	end
	if GearCheckReportTo["Party"] then
		if GetNumPartyMembers() > 0 then
			SendChatMessage(message, "PARTY");
		elseif GetNumRaidMembers() > 0 then
			SendChatMessage(message, "PARTY");
		end
	end
	if ((GearCheckReportTo["Raid"]) and (GetNumRaidMembers() > 0)) then
		SendChatMessage(message, "RAID");
	end
	if GearCheckReportTo["Guild"] then
		local guild = GetGuildInfo("player");		
		if (not(guild == nil)) then
			SendChatMessage(message, "GUILD");
		end
	end
	if GearCheckReportTo["Whisper"] then
		local h = GearCheckFrameWhisperBox:GetText();
		if (not (h == nil)) then
			SendChatMessage(message, "WHISPER", nil, h);
		end
	end
end

SlashCmdList["GC"] = function(args)
	if args == "toggle" then
		if GearCheckFrame:IsShown() then
			GearCheckFrame:Hide();
			GearCheckOptionsFrame:Hide();
		elseif not GearCheckFrame:IsShown() then
			GearCheckFrame:Show();
		end
	else
		local s, e = string.find(args, " ");
		if ((s == nil) and (e == nil)) then
		else
			local arg1 = string.sub(args, 0, e-1);
			local arg2 = string.sub(args, e+1);
			if (arg1 == "request") then
				GearCheckRequest(arg2);
			end
		end
	end
end

function GearCheckOnEvent(event, arg1, arg2, arg3, arg4)			
	if event == "PLAYER_ENTERING_WORLD" then		
		if not RegisterAddonMessagePrefix("GearCheck") then
			print(L["Error"]);
		else
		if not(guild == nil) then
			SendAddonMessage("GearCheck", "#"..GearCheckVersion, "GUILD");
		end
		if GetNumPartyMembers() > 0 then
			SendAddonMessage("GearCheck", "#"..GearCheckVersion, "PARTY");
		end
		if GetNumRaidMembers() > 0 then
			SendAddonMessage("GearCheck", "#"..GearCheckVersion, "RAID");
		end
		GearCheckFrameRequestButton:Disable();
		text = L["loadingGC"];
		waittime = 10;
		GearCheckWait(waittime, GearCheckFrameRequestButtonEnable);		
		end
	elseif event == "CHAT_MSG_ADDON" and arg1 == "GearCheck" then
		print(arg1.." "..arg2.." "..arg3.." "..arg4);
		--[[
		arg1=prefix 
		arg2=message 
		arg3=distribution type ("PARTY", "RAID", "GUILD", "BATTLEGROUND" or "WHISPER") 
		arg4=sender
		]]--
		if (not(arg4 == GetUnitName("PLAYER"))) then
			if (string.len(arg2) == 1) then
				if (arg2 == "?") then				
					GearCheckRespond(arg4);
				elseif (arg2 == "-") then
					GearCheckCurrentResults[arg4] = {-1, -1, -1};				
				end
			elseif (string.len(arg2) > 1) then
				local _, e = string.find(arg2, "!");
				if (not (e == nil)) then
					arg2 = string.sub(arg2, e+1);
					local hs, he = string.find(arg2, ",");
					local bil = string.sub(arg2, 0, hs-1);
					arg2 = string.sub(arg2, he+1);
					hs, he = string.find(arg2, ",");
					local ril = string.sub(arg2, 0, hs-1);
					arg2 = string.sub(arg2, he+1);
					local resiliance = tonumber(arg2);					
					GearCheckCurrentResults[arg4] = {tonumber(ril), tonumber(bil), tonumber(resiliance)};
				end
			end
		end
	elseif event == "ADDON_LOADED" and arg1 == "GearCheck" then		
		if GearCheckReportTo == nil then
			GearCheckReportTo = {};
			GearCheckReportTo["ChatFrame1"]=true;
			GearCheckReportTo["Say"]=false;
			GearCheckReportTo["Yell"]=false;
			GearCheckReportTo["Party"]=false;
			GearCheckReportTo["Raid"]=false;
			GearCheckReportTo["Guild"]=false;
			GearCheckReportTo["Whisper"]=false;
		end
		if GearCheck_LockFrames == nil then
			GearCheck_LockFrames = false;
		end
		if GearCheck_Respond == nil then
			GearCheck_Respond = true;
		end
		if GearCheck_LockMinimapButton == nil then
			GearCheck_LockMinimapButton = false;
		end
		if GearCheck_FramePosition == nil then
			GearCheck_FramePosition = {};
			GearCheck_FramePosition["point"] = "CENTER";
			GearCheck_FramePosition["x"] = 0;
			GearCheck_FramePosition["y"] = 0;
		end
		if GearCheck_MinimapButtonPosition == nil then
			GearCheck_MinimapButtonPosition = {};
			GearCheck_MinimapButtonPosition["point"] = "TOP";
			GearCheck_MinimapButtonPosition["x"] = 0;
			GearCheck_MinimapButtonPosition["y"] = 0;
		end
		if GearCheck_EnableMinimapButton == nil then
			GearCheck_EnableMinimapButton = true;
		end
		if GearCheck_LockShowLootFrame == nil then
			GearCheck_LockShowLootFrame = false;
		end
		if GearCheckOption == nil then
			GearCheckOption = {};
			GearCheckOption["Party"] = false;
			GearCheckOption["Raid"] = false
			GearCheckOption["Guild"] = false;
			GearCheckOption["target"] = true;
		end
		if GearCheckWhisperBox == nil then
			GearCheckWhisperBox = "";
		end
		if GearCheckTargetBox == nil then
			GearCheckTargetBox = "";
		end
		if GearCheckDB == nil then
			GearCheckDB = {};
		end
		
		GearCheckFrameWhisperBox:SetText(GearCheckWhisperBox);		
		
		GearCheckFrameCheckButtonChatFrame:SetChecked(GearCheckReportTo["ChatFrame1"]);
		GearCheckFrameCheckButtonSay:SetChecked(GearCheckReportTo["Say"]);
		GearCheckFrameCheckButtonYell:SetChecked(GearCheckReportTo["Yell"]);
		GearCheckFrameCheckButtonParty:SetChecked(GearCheckReportTo["Party"]);
		GearCheckFrameCheckButtonRaid:SetChecked(GearCheckReportTo["Raid"]);
		GearCheckFrameCheckButtonGuild:SetChecked(GearCheckReportTo["Guild"]);
		GearCheckFrameCheckButtonWhisper:SetChecked(GearCheckReportTo["Whisper"]);
		
		GearCheckCheckButtonParty:SetChecked(GearCheckOption["Party"]);
		GearCheckCheckButtonRaid:SetChecked(GearCheckOption["Raid"]);
		GearCheckCheckButtonGuild:SetChecked(GearCheckOption["Guild"]);
		
		GearCheckOptionsCheckButtonRespond:SetChecked(GearCheck_Respond);
		GearCheckOptionsCheckButtonLockFrames:SetChecked(GearCheck_LockFrames);
		GearCheckOptionsCheckButtonEnableMinimapButton:SetChecked(GearCheck_EnableMinimapButton);
		GearCheckOptionsCheckButtonLockMinimapButton:SetChecked(GearCheck_LockMinimapButton);		
		
		GearCheckFrame:SetPoint(GearCheck_FramePosition["point"], GearCheck_FramePosition["x"], GearCheck_FramePosition["y"]);
		
		if not GearCheck_LockFrames then		
			GearCheckFrame:RegisterForDrag("LeftButton");			
		end
				
		GearCheckMinimapButton:SetPoint(GearCheck_MinimapButtonPosition["point"], Minimap, GearCheck_MinimapButtonPosition["x"], GearCheck_MinimapButtonPosition["y"]);
		if GearCheck_EnableMinimapButton then
			GearCheckMinimapButton:Show();
		else
			GearCheckMinimapButton:Hide();
		end	
		if not GearCheck_LockMinimapButton then		
			GearCheckMinimapButton:RegisterForDrag("LeftButton");			
		end		
	end
end

--begin UI
UnitPopupButtons["GearCheck"]={text = "|cffff0000GearCheck|r", dist = 0};
tinsert(UnitPopupMenus["RAID_PLAYER"], 1, "GearCheck");
tinsert(UnitPopupMenus["PARTY"], 1, "GearCheck");
tinsert(UnitPopupMenus["PLAYER"], 1, "GearCheck");
hooksecurefunc("UnitPopup_OnClick", function(this)
	local dropdownFrame = UIDROPDOWNMENU_INIT_MENU
	local button = this.value
	local target = dropdownFrame.unit;	
	if button == "GearCheck" then
		GearCheckRequest(target);
	end	
end);

PAPERDOLL_STATINFO["REALITEMLEVEL"] = {
	updateFunc = function(statFrame, unit)
		local myItemLevel = GearCheckRound(GearCheckGetCurrentAverageItemLevel("player"), 0);
		PaperDollFrame_SetLabelAndText(statFrame, "Real Item-Level", myItemLevel)
		statFrame.tooltip = HIGHLIGHT_FONT_COLOR_CODE..format(PAPERDOLLFRAME_TOOLTIP_FORMAT, "Real Item-Level")..FONT_COLOR_CODE_CLOSE.." "..myItemLevel;
		statFrame.tooltip2 = L["REALITEMLEVEL"];
		statFrame:Show()
	end
	}
tinsert(PAPERDOLL_STATCATEGORIES["GENERAL"].stats, 5, "REALITEMLEVEL")

GameTooltip:HookScript("OnShow", function(self)
	GameTooltipOnShow = GameTooltipOnShow * -1;
	local a, b = self:GetUnit()
	if GameTooltipOnShow == 1 then
		if ((not (a == nil)) and (UnitIsPlayer(b))) then
			local name = GetUnitName(b, true);			
			local pos = strfind(name, "-");
			if pos == nil then
				name = name.."-"..GearCheckRealm;
			end			
			if (not (GearCheckDB[name] == nil)) then			
				if GearCheckDB[name][1] > 0 then
					GameTooltip:AddLine(" ");
					GameTooltip:AddLine("RIL: "..GearCheckDB[name][1],1 ,1 ,1);
					if GearCheckDB[name][2] > 0 then
						GameTooltip:AddLine("BIL: "..GearCheckDB[name][2],1 ,1 ,1);				
					end
					if GearCheckDB[name][3] > 0 then
						GameTooltip:AddLine(L["resi"]..": "..GearCheckDB[name][3],1 ,1 ,1);				
					end
				end	
			end
		end
	end	
end);

GearCheckWaitFrame = CreateFrame("Frame","GearCheckWaitFrame", UIParent);
GearCheckWaitFrame:SetScript("OnUpdate", function(self,elapsed) GearCheckWaitFrameOnUpdate(self, elapsed); end);

GearCheckMinimapButton = CreateFrame("BUTTON", "GearCheckMinimapButton", Minimap);
GearCheckMinimapButton:SetWidth(31);
GearCheckMinimapButton:SetHeight(31);
GearCheckMinimapButton:SetFrameStrata("LOW");
GearCheckMinimapButton:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight");
GearCheckMinimapButton:SetPoint("RIGHT", Minimap, "LEFT");
GearCheckMinimapButtonIcon = GearCheckMinimapButton:CreateTexture(nil, "BACKGROUND");
GearCheckMinimapButtonIcon:SetTexture("Interface\\AddOns\\GearCheck\\GearCheckIcon");
GearCheckMinimapButtonIcon:SetPoint("TOPLEFT", 6, -6);
GearCheckMinimapButtonIcon:SetPoint("BOTTOMRIGHT", -6, 6);
GearCheckMinimapButtonOverlay = GearCheckMinimapButton:CreateTexture(nil, "OVERLAY");
GearCheckMinimapButtonOverlay:SetTexture("Interface\\Minimap\\MiniMap-TrackingBorder");
GearCheckMinimapButtonOverlay:SetWidth(53);
GearCheckMinimapButtonOverlay:SetHeight(53);
GearCheckMinimapButtonOverlay:SetPoint("TOPLEFT");
GearCheckMinimapButton:SetMovable(true);
GearCheckMinimapButton:EnableMouse(true);
GearCheckMinimapButton:SetScript("OnDragStart", function() GearCheckMinimapButton:StartMoving() end);
GearCheckMinimapButton:SetScript("OnDragStop", function()
													GearCheckMinimapButton:StopMovingOrSizing();
													local point, relativeTo, relativePoint, x, y = GearCheckMinimapButton:GetPoint();
													GearCheck_MinimapButtonPosition["point"] = point;													
													GearCheck_MinimapButtonPosition["x"] = x;
													GearCheck_MinimapButtonPosition["y"] = y;
												 end);
GearCheckMinimapButton:SetScript("OnClick", function()
												if GearCheckFrame:IsShown() then
													GearCheckFrame:Hide();
													GearCheckOptionsFrame:Hide();
												elseif not GearCheckFrame:IsShown() then
													GearCheckFrame:Show();
												end												
											end);										
GearCheckMinimapButton:Hide();

GearCheckFrame = CreateFrame("FRAME", "GearCheckFrame", UIParent);
GearCheckFrame:SetWidth(200);
GearCheckFrame:SetHeight(265);
GearCheckFrame:RegisterEvent("ADDON_LOADED");
GearCheckFrame:RegisterEvent("CHAT_MSG_ADDON");
GearCheckFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
GearCheckFrame:SetScript("OnEvent", function(self, event, arg1, arg2, arg3, arg4, ...)
										GearCheckOnEvent(event, arg1, arg2, arg3, arg4);
										end);
GearCheckFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GearCheckFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
GearCheckFrame:EnableMouse(true);
GearCheckFrame:SetMovable(true);
GearCheckFrame:SetUserPlaced(true);
GearCheckFrame:SetScript("OnDragStart", function(this) this:StartMoving(); end);
GearCheckFrame:SetScript("OnDragStop", function()
											GearCheckFrame:StopMovingOrSizing();
											local point, relativeTo, relativePoint, x, y = GearCheckFrame:GetPoint();
											GearCheck_FramePosition["point"] = point;													
											GearCheck_FramePosition["x"] = x;
											GearCheck_FramePosition["y"] = y;
										  end);
GearCheckFrame:Hide();
tinsert(UISpecialFrames, GearCheckFrame:GetName());

local GearCheckTopFrame = CreateFrame("FRAME", nil, GearCheckFrame);
GearCheckTopFrame:SetWidth(120);
GearCheckTopFrame:SetHeight(25);
GearCheckTopFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GearCheckTopFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
GearCheckTopFrame:SetPoint("TOP", 0, 10);
GearCheckTopFrame:Show();

local GearCheckFrameText = GearCheckTopFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckFrameText:SetTextColor(1, 0, 0, 1.0);
GearCheckFrameText:SetText(GearCheckVersion);
GearCheckFrameText:SetPoint("CENTER");

local GearCheckFrameOptions = CreateFrame("BUTTON", nil, GearCheckFrame, "UIPanelButtonTemplate");
GearCheckFrameOptions:SetWidth(15);
GearCheckFrameOptions:SetHeight(15);
GearCheckFrameOptions:SetText("O");
GearCheckFrameOptions:SetPoint("TOPLEFT", 5, -5);
GearCheckFrameOptions:SetScript("OnClick", function()
												if GearCheckOptionsFrame:IsShown() then
													GearCheckOptionsFrame:Hide();													
												elseif not GearCheckOptionsFrame:IsShown() then
													GearCheckOptionsFrame:Show();
												end											
											 end);
GearCheckFrameOptions:SetAlpha(1);
GearCheckFrameOptions:Show();

local GearCheckFrameClose = CreateFrame("BUTTON", nil, GearCheckFrame, "UIPanelButtonTemplate");
GearCheckFrameClose:SetWidth(15);
GearCheckFrameClose:SetHeight(15);
GearCheckFrameClose:SetText("X");
GearCheckFrameClose:SetPoint("TOPRIGHT", -5, -5);
GearCheckFrameClose:SetScript("OnClick", function()
											GearCheckFrame:Hide();
											GearCheckOptionsFrame:Hide();
										   end);
GearCheckFrameClose:SetAlpha(1);
GearCheckFrameClose:Show();

local GearCheckFrameText2 = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckFrameText2:SetTextColor(1.0, 0.8, 0, 0.8);
GearCheckFrameText2:SetWidth(175);
GearCheckFrameText2:SetJustifyH("LEFT");
GearCheckFrameText2:SetText(L["Report:"]);
GearCheckFrameText2:SetPoint("TOPLEFT", 5, -30);

local GearCheckFrameChatFrame = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckFrameChatFrame:SetTextColor(1, 1, 1, 0.8);
GearCheckFrameChatFrame:SetWidth(175);
GearCheckFrameChatFrame:SetHeight(15);
GearCheckFrameChatFrame:SetJustifyH("LEFT");
GearCheckFrameChatFrame:SetText(L["ChatFrame1"]);
GearCheckFrameChatFrame:SetPoint("TOP", GearCheckFrameText2, "BOTTOM", 25, -5);

GearCheckFrameCheckButtonChatFrame = CreateFrame("CHECKBUTTON", nil, GearCheckFrame);
GearCheckFrameCheckButtonChatFrame:SetWidth(15);
GearCheckFrameCheckButtonChatFrame:SetHeight(15);
GearCheckFrameCheckButtonChatFrame:SetPoint("RIGHT", GearCheckFrameChatFrame, "LEFT", -5, 0);
GearCheckFrameCheckButtonChatFrame:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckFrameCheckButtonChatFrame:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckFrameCheckButtonChatFrame:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckFrameCheckButtonChatFrame:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckFrameCheckButtonChatFrame:SetScript("OnClick", function() GearCheckReportTo["ChatFrame1"] = GearChecktobool(GearCheckFrameCheckButtonChatFrame:GetChecked()); end);
GearCheckFrameCheckButtonChatFrame:Show();

local GearCheckFrameSay = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckFrameSay:SetTextColor(1, 1, 1, 0.8);
GearCheckFrameSay:SetWidth(175);
GearCheckFrameSay:SetHeight(15);
GearCheckFrameSay:SetJustifyH("LEFT");
GearCheckFrameSay:SetText(L["/say"]);
GearCheckFrameSay:SetPoint("TOP", GearCheckFrameChatFrame, "BOTTOM", 0, 0);

GearCheckFrameCheckButtonSay = CreateFrame("CHECKBUTTON", nil, GearCheckFrame);
GearCheckFrameCheckButtonSay:SetWidth(15);
GearCheckFrameCheckButtonSay:SetHeight(15);
GearCheckFrameCheckButtonSay:SetPoint("RIGHT", GearCheckFrameSay, "LEFT", -5, 0);
GearCheckFrameCheckButtonSay:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckFrameCheckButtonSay:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckFrameCheckButtonSay:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckFrameCheckButtonSay:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckFrameCheckButtonSay:SetScript("OnClick", function() GearCheckReportTo["Say"] = GearChecktobool(GearCheckFrameCheckButtonSay:GetChecked()); end);
GearCheckFrameCheckButtonSay:Show();

local GearCheckFrameYell = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckFrameYell:SetTextColor(1, 1, 1, 0.8);
GearCheckFrameYell:SetWidth(175);
GearCheckFrameYell:SetHeight(15);
GearCheckFrameYell:SetJustifyH("LEFT");
GearCheckFrameYell:SetText(L["/yell"]);
GearCheckFrameYell:SetPoint("TOP", GearCheckFrameSay, "BOTTOM", 0, 0);

GearCheckFrameCheckButtonYell = CreateFrame("CHECKBUTTON", nil, GearCheckFrame);
GearCheckFrameCheckButtonYell:SetWidth(15);
GearCheckFrameCheckButtonYell:SetHeight(15);
GearCheckFrameCheckButtonYell:SetPoint("RIGHT", GearCheckFrameYell, "LEFT", -5, 0);
GearCheckFrameCheckButtonYell:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckFrameCheckButtonYell:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckFrameCheckButtonYell:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckFrameCheckButtonYell:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckFrameCheckButtonYell:SetScript("OnClick", function() GearCheckReportTo["Yell"] = GearChecktobool(GearCheckFrameCheckButtonYell:GetChecked()); end);
GearCheckFrameCheckButtonYell:Show();

local GearCheckFrameParty = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckFrameParty:SetTextColor(1, 1, 1, 0.8);
GearCheckFrameParty:SetWidth(175);
GearCheckFrameParty:SetHeight(15);
GearCheckFrameParty:SetJustifyH("LEFT");
GearCheckFrameParty:SetText(L["/party"]);
GearCheckFrameParty:SetPoint("TOP", GearCheckFrameYell, "BOTTOM", 0, 0);

GearCheckFrameCheckButtonParty = CreateFrame("CHECKBUTTON", nil, GearCheckFrame);
GearCheckFrameCheckButtonParty:SetWidth(15);
GearCheckFrameCheckButtonParty:SetHeight(15);
GearCheckFrameCheckButtonParty:SetPoint("RIGHT", GearCheckFrameParty, "LEFT", -5, 0);
GearCheckFrameCheckButtonParty:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckFrameCheckButtonParty:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckFrameCheckButtonParty:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckFrameCheckButtonParty:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckFrameCheckButtonParty:SetScript("OnClick", function() GearCheckReportTo["Party"] = GearChecktobool(GearCheckFrameCheckButtonParty:GetChecked()); end);
GearCheckFrameCheckButtonParty:Show();

local GearCheckFrameRaidtxt = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckFrameRaidtxt:SetTextColor(1, 1, 1, 0.8);
GearCheckFrameRaidtxt:SetWidth(175);
GearCheckFrameRaidtxt:SetHeight(15);
GearCheckFrameRaidtxt:SetJustifyH("LEFT");
GearCheckFrameRaidtxt:SetText(L["/raid"]);
GearCheckFrameRaidtxt:SetPoint("TOP", GearCheckFrameParty, "BOTTOM", 0, 0);

GearCheckFrameCheckButtonRaid = CreateFrame("CHECKBUTTON", nil, GearCheckFrame);
GearCheckFrameCheckButtonRaid:SetWidth(15);
GearCheckFrameCheckButtonRaid:SetHeight(15);
GearCheckFrameCheckButtonRaid:SetPoint("RIGHT", GearCheckFrameRaidtxt, "LEFT", -5, 0);
GearCheckFrameCheckButtonRaid:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckFrameCheckButtonRaid:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckFrameCheckButtonRaid:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckFrameCheckButtonRaid:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");	
GearCheckFrameCheckButtonRaid:SetScript("OnClick", function() GearCheckReportTo["Raid"] = GearChecktobool(GearCheckFrameCheckButtonRaid:GetChecked()); end);
GearCheckFrameCheckButtonRaid:Show();

local GearCheckFrameGuild = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckFrameGuild:SetTextColor(1, 1, 1, 0.8);
GearCheckFrameGuild:SetWidth(175);
GearCheckFrameGuild:SetHeight(15);
GearCheckFrameGuild:SetJustifyH("LEFT");
GearCheckFrameGuild:SetText(L["/guild"]);
GearCheckFrameGuild:SetPoint("TOP", GearCheckFrameRaidtxt, "BOTTOM", 0, 0);

GearCheckFrameCheckButtonGuild = CreateFrame("CHECKBUTTON", nil, GearCheckFrame);
GearCheckFrameCheckButtonGuild:SetWidth(15);
GearCheckFrameCheckButtonGuild:SetHeight(15);
GearCheckFrameCheckButtonGuild:SetPoint("RIGHT", GearCheckFrameGuild, "LEFT", -5, 0);
GearCheckFrameCheckButtonGuild:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckFrameCheckButtonGuild:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckFrameCheckButtonGuild:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckFrameCheckButtonGuild:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckFrameCheckButtonGuild:SetScript("OnClick", function() GearCheckReportTo["Guild"] = GearChecktobool(GearCheckFrameCheckButtonGuild:GetChecked()); end);
GearCheckFrameCheckButtonGuild:Show();

local GearCheckFrameWhisper = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckFrameWhisper:SetTextColor(1, 1, 1, 0.8);
GearCheckFrameWhisper:SetWidth(100);
GearCheckFrameWhisper:SetHeight(15);
GearCheckFrameWhisper:SetJustifyH("LEFT");
GearCheckFrameWhisper:SetText(L["/whisper:"]);
GearCheckFrameWhisper:SetPoint("TOPLEFT", GearCheckFrameGuild, "BOTTOMLEFT");

GearCheckFrameCheckButtonWhisper = CreateFrame("CHECKBUTTON", nil, GearCheckFrame);
GearCheckFrameCheckButtonWhisper:SetWidth(15);
GearCheckFrameCheckButtonWhisper:SetHeight(15);
GearCheckFrameCheckButtonWhisper:SetPoint("RIGHT", GearCheckFrameWhisper, "LEFT", -5, 0);
GearCheckFrameCheckButtonWhisper:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckFrameCheckButtonWhisper:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckFrameCheckButtonWhisper:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckFrameCheckButtonWhisper:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckFrameCheckButtonWhisper:SetScript("OnClick", function() GearCheckReportTo["Whisper"] = GearChecktobool(GearCheckFrameCheckButtonWhisper:GetChecked()); end);
GearCheckFrameCheckButtonWhisper:Show();

local GearCheckFrameWhisperBox = CreateFrame("EDITBOX", "GearCheckFrameWhisperBox", GearCheckFrame, "InputBoxTemplate")
GearCheckFrameWhisperBox:SetWidth(90);
GearCheckFrameWhisperBox:SetHeight(15);
GearCheckFrameWhisperBox:SetPoint("LEFT", GearCheckFrameWhisper, "RIGHT", -40, -2);
GearCheckFrameWhisperBox:SetMaxLetters(12);
GearCheckFrameWhisperBox:SetScript("OnTabPressed", function()
													local n, r = UnitName("TARGET");
														if not (n == nil) then
														GearCheckFrameWhisperBox:SetText(n);
													end
												end);

GearCheckFrameWhisperBox:SetScript("OnEnterPressed", function() GearCheckFrameWhisperBox:ClearFocus(); end);
GearCheckFrameWhisperBox:SetScript("OnTextChanged", function()
	local h = GearCheckFrameWhisperBox:GetText()
	if #h == 1 then
		GearCheckFrameWhisperBox:SetText(strupper(h));
	elseif #h > 1 then
		local a = strsub(h, 1, 1);
		local b = strsub(h, 2);		
		GearCheckFrameWhisperBox:SetText(strupper(a)..strlower(b));
	end
	GearCheckWhisperBox = GearCheckFrameWhisperBox:GetText();
end);
GearCheckFrameWhisperBox:SetAutoFocus(false);
GearCheckFrameWhisperBox:Show();

local GearCheckFrameText3 = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckFrameText3:SetTextColor(1.0, 0.8, 0, 0.8);
GearCheckFrameText3:SetWidth(175);
GearCheckFrameText3:SetJustifyH("LEFT");
GearCheckFrameText3:SetText(L["Check:"]);
GearCheckFrameText3:SetPoint("TOPLEFT", GearCheckFrameCheckButtonWhisper, "BOTTOMLEFT", 0, -10);

local GearCheckOptionParty = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionParty:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionParty:SetWidth(45);
GearCheckOptionParty:SetHeight(15);
GearCheckOptionParty:SetJustifyH("LEFT");
GearCheckOptionParty:SetText(L["party"]);
GearCheckOptionParty:SetPoint("TOPLEFT", GearCheckFrameText3, "BOTTOMLEFT", 15, -5);

GearCheckCheckButtonParty = CreateFrame("CHECKBUTTON", nil, GearCheckFrame);
GearCheckCheckButtonParty:SetWidth(15);
GearCheckCheckButtonParty:SetHeight(15);
GearCheckCheckButtonParty:SetPoint("RIGHT", GearCheckOptionParty, "LEFT", 0, 0);
GearCheckCheckButtonParty:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckCheckButtonParty:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckCheckButtonParty:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckCheckButtonParty:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckCheckButtonParty:SetScript("OnClick", function()
													GearCheckCheckButtonParty:SetChecked(true);
													GearCheckOption["Party"] = true;
													GearCheckCheckButtonRaid:SetChecked(false);
													GearCheckOption["Raid"] = false
													GearCheckCheckButtonGuild:SetChecked(false);
													GearCheckOption["Guild"] = false;													
												end);
GearCheckCheckButtonParty:Show();

local GearCheckOptionRaid = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionRaid:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionRaid:SetWidth(45);
GearCheckOptionRaid:SetHeight(15);
GearCheckOptionRaid:SetJustifyH("LEFT");
GearCheckOptionRaid:SetText(L["raid"]);
GearCheckOptionRaid:SetPoint("LEFT", GearCheckOptionParty, "RIGHT", 20, 0);

GearCheckCheckButtonRaid = CreateFrame("CHECKBUTTON", nil, GearCheckFrame);
GearCheckCheckButtonRaid:SetWidth(15);
GearCheckCheckButtonRaid:SetHeight(15);
GearCheckCheckButtonRaid:SetPoint("RIGHT", GearCheckOptionRaid, "LEFT", 0, 0);
GearCheckCheckButtonRaid:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckCheckButtonRaid:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckCheckButtonRaid:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckCheckButtonRaid:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckCheckButtonRaid:SetScript("OnClick", function()
													GearCheckCheckButtonParty:SetChecked(false);
													GearCheckOption["Party"] = false;
													GearCheckCheckButtonRaid:SetChecked(true);
													GearCheckOption["Raid"] = true
													GearCheckCheckButtonGuild:SetChecked(false);
													GearCheckOption["Guild"] = false;													
												end);

GearCheckCheckButtonRaid:Show();

local GearCheckOptionGuild = GearCheckFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionGuild:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionGuild:SetWidth(45);
GearCheckOptionGuild:SetHeight(15);
GearCheckOptionGuild:SetJustifyH("LEFT");
GearCheckOptionGuild:SetText(L["guild"]);
GearCheckOptionGuild:SetPoint("LEFT", GearCheckOptionRaid, "RIGHT", 20, 0);

GearCheckCheckButtonGuild = CreateFrame("CHECKBUTTON", nil, GearCheckFrame);
GearCheckCheckButtonGuild:SetWidth(15);
GearCheckCheckButtonGuild:SetHeight(15);
GearCheckCheckButtonGuild:SetPoint("RIGHT", GearCheckOptionGuild, "LEFT", 0, 0);
GearCheckCheckButtonGuild:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckCheckButtonGuild:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckCheckButtonGuild:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckCheckButtonGuild:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckCheckButtonGuild:SetScript("OnClick", function()
													GearCheckCheckButtonParty:SetChecked(false);
													GearCheckOption["Party"] = false;
													GearCheckCheckButtonRaid:SetChecked(false);
													GearCheckOption["Raid"] = false
													GearCheckCheckButtonGuild:SetChecked(true);
													GearCheckOption["Guild"] = true;													
												end);

GearCheckCheckButtonGuild:Show();

GearCheckFrameRequestButton = CreateFrame("BUTTON", nil, GearCheckFrame, "UIPanelButtonTemplate");
GearCheckFrameRequestButton:SetWidth(180);
GearCheckFrameRequestButton:SetHeight(40);
GearCheckFrameRequestButton:SetText(L["requestGC"]);
GearCheckFrameRequestButton:SetPoint("TOPLEFT", GearCheckCheckButtonParty, "BOTTOMLEFT", 0, -15);
GearCheckFrameRequestButton:SetScript("OnClick", function()
													if GearCheckCheckButtonParty:GetChecked() then
														GearCheckRequest("PARTY");
													elseif GearCheckCheckButtonRaid:GetChecked() then
														GearCheckRequest("RAID");
													elseif GearCheckCheckButtonGuild:GetChecked() then
														GearCheckRequest("GUILD");													
													end
												end);
GearCheckFrameRequestButton:SetAlpha(1);
GearCheckFrameRequestButton:Show();

local GearCheckOptionsFrame = CreateFrame("FRAME", "GearCheckOptionsFrame", UIParent);
GearCheckOptionsFrame:SetWidth(200);
GearCheckOptionsFrame:SetHeight(100);
GearCheckOptionsFrame:SetBackdrop({bgFile = "Interface/Tooltips/UI-Tooltip-Background", edgeFile = "Interface/DialogFrame/UI-Dialogbox-Border", tile = true, tileSize = 16, edgeSize = 16, insets = { left = 4, right = 4, top = 4, bottom = 4 }});
GearCheckOptionsFrame:SetBackdropColor(0.0,0.0,0.0,0.9);
GearCheckOptionsFrame:SetPoint("TOP", GearCheckFrame, "BOTTOM", 0, 0);
tinsert(UISpecialFrames, GearCheckOptionsFrame:GetName());
GearCheckOptionsFrame:Hide();

local GearCheckOptionsText3 = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsText3:SetTextColor(1.0, 0.8, 0, 0.8);
GearCheckOptionsText3:SetWidth(150);
GearCheckOptionsText3:SetJustifyH("LEFT");
GearCheckOptionsText3:SetText(L["Options:"]);
GearCheckOptionsText3:SetPoint("TOPLEFT", 5, -10);

local GearCheckOptionsRespond = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsRespond:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsRespond:SetWidth(175);
GearCheckOptionsRespond:SetHeight(15);
GearCheckOptionsRespond:SetJustifyH("LEFT");
GearCheckOptionsRespond:SetText(L["Respond"]);
GearCheckOptionsRespond:SetPoint("TOPLEFT", GearCheckOptionsText3, "BOTTOMLEFT", 25, -5);

GearCheckOptionsCheckButtonRespond = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonRespond:SetWidth(15);
GearCheckOptionsCheckButtonRespond:SetHeight(15);
GearCheckOptionsCheckButtonRespond:SetPoint("RIGHT", GearCheckOptionsRespond, "LEFT", -5, 0);
GearCheckOptionsCheckButtonRespond:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonRespond:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonRespond:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonRespond:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonRespond:SetScript("OnClick", function() 
																GearCheck_Respond = GearChecktobool(GearCheckOptionsCheckButtonRespond:GetChecked());															
															 end);
GearCheckOptionsCheckButtonRespond:Show();


local GearCheckOptionsLockFrames = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsLockFrames:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsLockFrames:SetWidth(175);
GearCheckOptionsLockFrames:SetHeight(15);
GearCheckOptionsLockFrames:SetJustifyH("LEFT");
GearCheckOptionsLockFrames:SetText(L["lockFrames"]);
GearCheckOptionsLockFrames:SetPoint("TOPLEFT", GearCheckOptionsRespond, "BOTTOMLEFT", 0, 0);

GearCheckOptionsCheckButtonLockFrames = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonLockFrames:SetWidth(15);
GearCheckOptionsCheckButtonLockFrames:SetHeight(15);
GearCheckOptionsCheckButtonLockFrames:SetPoint("RIGHT", GearCheckOptionsLockFrames, "LEFT", -5, 0);
GearCheckOptionsCheckButtonLockFrames:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonLockFrames:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonLockFrames:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonLockFrames:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonLockFrames:SetScript("OnClick", function() 
																GearCheck_LockFrames = GearChecktobool(GearCheckOptionsCheckButtonLockFrames:GetChecked());
																if GearCheckOptionsCheckButtonLockFrames:GetChecked() then
																	GearCheckFrame:RegisterForDrag("");
																elseif not GearCheckOptionsCheckButtonLockFrames:GetChecked() then
																	GearCheckFrame:RegisterForDrag("LeftButton");
																end
															 end);
GearCheckOptionsCheckButtonLockFrames:Show();

local GearCheckOptionsEnableMinimapButton = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsEnableMinimapButton:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsEnableMinimapButton:SetWidth(175);
GearCheckOptionsEnableMinimapButton:SetHeight(15);
GearCheckOptionsEnableMinimapButton:SetJustifyH("LEFT");
GearCheckOptionsEnableMinimapButton:SetText(L["enableMinimapButton"]);
GearCheckOptionsEnableMinimapButton:SetPoint("TOPLEFT", GearCheckOptionsLockFrames, "BOTTOMLEFT", 0, 0);

GearCheckOptionsCheckButtonEnableMinimapButton = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonEnableMinimapButton:SetWidth(15);
GearCheckOptionsCheckButtonEnableMinimapButton:SetHeight(15);
GearCheckOptionsCheckButtonEnableMinimapButton:SetPoint("RIGHT", GearCheckOptionsEnableMinimapButton, "LEFT", -5, 0);
GearCheckOptionsCheckButtonEnableMinimapButton:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonEnableMinimapButton:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonEnableMinimapButton:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonEnableMinimapButton:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonEnableMinimapButton:SetScript("OnClick", function() 
																		GearCheck_EnableMinimapButton = GearChecktobool(GearCheckOptionsCheckButtonEnableMinimapButton:GetChecked());
																		if GearCheckOptionsCheckButtonEnableMinimapButton:GetChecked() then
																			GearCheckMinimapButton:Show();
																		elseif not GearCheckOptionsCheckButtonEnableMinimapButton:GetChecked() then
																			GearCheckMinimapButton:Hide();
																		end
																	  end);
GearCheckOptionsCheckButtonEnableMinimapButton:Show();

local GearCheckOptionsLockMinimapButton = GearCheckOptionsFrame:CreateFontString(nil, "Artwork", "ChatFontNormal");
GearCheckOptionsLockMinimapButton:SetTextColor(1, 1, 1, 0.8);
GearCheckOptionsLockMinimapButton:SetWidth(175);
GearCheckOptionsLockMinimapButton:SetHeight(15);
GearCheckOptionsLockMinimapButton:SetJustifyH("LEFT");
GearCheckOptionsLockMinimapButton:SetText(L["lockMinimapButton"]);
GearCheckOptionsLockMinimapButton:SetPoint("TOPLEFT", GearCheckOptionsEnableMinimapButton, "BOTTOMLEFT", 0, 0);

GearCheckOptionsCheckButtonLockMinimapButton = CreateFrame("CHECKBUTTON", nil, GearCheckOptionsFrame);
GearCheckOptionsCheckButtonLockMinimapButton:SetWidth(15);
GearCheckOptionsCheckButtonLockMinimapButton:SetHeight(15);
GearCheckOptionsCheckButtonLockMinimapButton:SetPoint("RIGHT", GearCheckOptionsLockMinimapButton, "LEFT", -5, 0);
GearCheckOptionsCheckButtonLockMinimapButton:SetNormalTexture("Interface\\Buttons\\UI-CheckBox-Up");
GearCheckOptionsCheckButtonLockMinimapButton:SetPushedTexture("Interface\\Buttons\\UI-CheckBox-Down");
GearCheckOptionsCheckButtonLockMinimapButton:SetHighlightTexture("Interface\\Buttons\\UI-CheckBox-Highlight", "ADD");
GearCheckOptionsCheckButtonLockMinimapButton:SetCheckedTexture("Interface\\Buttons\\UI-CheckBox-Check");
GearCheckOptionsCheckButtonLockMinimapButton:SetScript("OnClick", function()
																		GearCheck_LockMinimapButton = GearChecktobool(GearCheckOptionsCheckButtonLockMinimapButton:GetChecked());
																		if GearCheckOptionsCheckButtonLockMinimapButton:GetChecked() then
																			GearCheckMinimapButton:RegisterForDrag(""); 
																		elseif not GearCheckOptionsCheckButtonLockMinimapButton:GetChecked() then																			
																			GearCheckMinimapButton:RegisterForDrag("LeftButton");
																		end
																	end);
GearCheckOptionsCheckButtonLockMinimapButton:Show();
-- end UI
